package de.moritzruth.dracula_musical.song

import de.moritzruth.dracula_musical.device.*
import de.moritzruth.theaterdsl.show.SceneBuilderContext
import de.moritzruth.theaterdsl.show.StepCue
import de.moritzruth.theaterdsl.value.Color
import de.moritzruth.theaterdsl.value.degrees
import de.moritzruth.theaterdsl.value.percent
import kotlin.time.Duration.Companion.minutes
import kotlin.time.Duration.Companion.seconds

fun SceneBuilderContext.songDuett() {
    lightStep(StepCue.MusicStart("Duett", 3.minutes + 15.seconds)) {
        FrontLights.all { it.brightness.fade(40.percent, 5.seconds) }
        Washs.both {
            it.pointAtCeiling()
            it.colorWheelMode.static(CoemarProWash.ColorWheelMode.White)
            it.magenta.static(100.percent)
        }
    }

    lightStep(StepCue.Custom("Strophe")) {
        BlinderBars.all {
            it.preset.static(StairvilleSplb.Preset.STUB)  // dreamy, flowy, pink, warm
            it.presetSpeed.static(10.percent)
            it.brightness.fade(25.percent, 5.seconds)
        }
    }

    lightStep(StepCue.Text("Mina & Jonathan", "Von dem Gefühl im Bauch…")) {
        backlightBar.color.static(Color(300.degrees))
        backlightBar.brightness.fade(40.percent, 6.seconds)
    }

    step(StepCue.Text("Mina & Jonathan", "Ich weiß nur eins…")) {
        leftSpotTarget = "Mina & Jonathan"

        onRun {
            Spots.left.brightness.fade(100.percent, 8.seconds)
        }
    }

    lightStep(StepCue.MusicEnd) {
        Spots.left.brightness.off(10.seconds)
        FrontLights.all { it.brightness.fade(75.percent, 10.seconds) }
        BlinderBars.all { it.brightness.off(4.seconds) }
        Washs.both { it.brightness.off(4.seconds) }
        backlightBar.brightness.off(6.seconds)
    }
}